/*
 * ArrayStack.java
 *
 * Modified on pondelok, 3. 11. 2008, 1.33
 *
 */
package cz.muni.fi.pb162.stack;

import java.util.Arrays;

/**
 * Stack (LIFO) data structure implemented by dynamicly resized array
 *
 * @author Michal Oprendek
 * @version 1.0
 */
public class ArrayStack<T> implements Stack<T> {

    //hlavna datova struktura -- v nej je implementovany zasobnik
    private Object[] data = new Object[10];
    //indikuje prazdny zasobnik ak je minus jedna, inak ukazuje na vrchol zasobniku
    private int top = -1;

    public boolean isEmpty() {
        return top < 0;
    }

    public T pop() {

        T result = null;

        result = (T) data[top];
        data[top] = null;           //nevyhnutne pre zabranenie memory leak

        top--;

        return result;
    }

    /**
     * Inserts object on the top of the stack, doubles the size of array if needed
     *
     * @param o inserted object
     */
    public void push(T o) {

        top++;

        if (top >= data.length) {
            //zdvojnasobenie dlzky pola
            data = Arrays.copyOf(data, data.length * 2);
        }

        data[top] = o;

    }

    public T peek() {
        return (T) data[top];
    }
}
